(ns bug.bug
  (:require
    #?@(:clj [[clojure.java.jdbc :as jdbc]
              [clojure.pprint :refer [pprint]]])
    [om.tempid :as tempid :refer [tempid?]]
    ))

(defmulti guts-insert (fn [g-conn db-conn table-name data] table-name))
(declare ensure-table-by-name)

(def alias-tempid? tempid? )

#?(:clj
    (defmethod guts-insert :default
      [g-conn db-conn table-name data]
      (let [
            {:keys [table/v-primary-key
                    table/version-field]} (ensure-table-by-name g-conn
                                                                table-name
                                                                [:table/v-primary-key
                                                                 :table/version-field])
            first-key (first v-primary-key)
            fk-value (get data first-key)
            is-tid (tempid? fk-value)  ;; produces bug
            ;; is-tid (om.tempid/tempid? fk-value) ;; produces bug also
            ;; is-tid (alias-tempid? fk-value) ;; local aliased value passes
            data (cond-> data
                   is-tid
                   (dissoc first-key)

                   version-field
                   (assoc version-field 0))
            data (jdbc/insert! db-conn table-name data)
            fk-new-value (get data first-key)
            tempids (if fk-new-value {fk-value fk-new-value} {})]
        (when is-tid
          (assert fk-new-value "the database did not generate an id on guts-insert"))
        {:data data
         :tempids tempids}
        )
      ))


